"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@ng-dynamic-forms/core");
var DynamicFoundationFormControlComponent = /** @class */ (function (_super) {
    __extends(DynamicFoundationFormControlComponent, _super);
    function DynamicFoundationFormControlComponent(changeDetectorRef, validationService) {
        var _this = _super.call(this, changeDetectorRef, validationService) || this;
        _this.changeDetectorRef = changeDetectorRef;
        _this.validationService = validationService;
        _this.bindId = true;
        _this.context = null;
        _this.hasErrorMessaging = false;
        _this.blur = new core_1.EventEmitter();
        _this.change = new core_1.EventEmitter();
        _this.focus = new core_1.EventEmitter();
        return _this;
    }
    DynamicFoundationFormControlComponent_1 = DynamicFoundationFormControlComponent;
    DynamicFoundationFormControlComponent.prototype.ngOnChanges = function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
        if (changes["model"]) {
            this.type = DynamicFoundationFormControlComponent_1.getFormControlType(this.model);
        }
    };
    DynamicFoundationFormControlComponent.getFormControlType = function (model) {
        switch (model.type) {
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return 1 /* Array */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return 2 /* Checkbox */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return 3 /* Group */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return 4 /* Input */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return 5 /* RadioGroup */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return 6 /* Select */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_SWITCH:
                return 7 /* Switch */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return 8 /* TextArea */;
            default:
                return null;
        }
    };
    __decorate([
        core_1.ContentChildren(core_2.DynamicTemplateDirective),
        __metadata("design:type", core_1.QueryList)
    ], DynamicFoundationFormControlComponent.prototype, "contentTemplates", void 0);
    __decorate([
        core_1.Input("templates"),
        __metadata("design:type", core_1.QueryList)
    ], DynamicFoundationFormControlComponent.prototype, "inputTemplates", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], DynamicFoundationFormControlComponent.prototype, "bindId", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DynamicFoundationFormControlComponent.prototype, "context", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", forms_1.FormGroup)
    ], DynamicFoundationFormControlComponent.prototype, "group", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], DynamicFoundationFormControlComponent.prototype, "hasErrorMessaging", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", core_2.DynamicFormControlModel)
    ], DynamicFoundationFormControlComponent.prototype, "model", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DynamicFoundationFormControlComponent.prototype, "blur", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DynamicFoundationFormControlComponent.prototype, "change", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DynamicFoundationFormControlComponent.prototype, "focus", void 0);
    DynamicFoundationFormControlComponent = DynamicFoundationFormControlComponent_1 = __decorate([
        core_1.Component({
            selector: "dynamic-foundation-form-control,dynamic-form-foundation-sites-control",
            templateUrl: "./dynamic-foundation-form-control.component.html"
        }),
        __metadata("design:paramtypes", [core_1.ChangeDetectorRef,
            core_2.DynamicFormValidationService])
    ], DynamicFoundationFormControlComponent);
    return DynamicFoundationFormControlComponent;
    var DynamicFoundationFormControlComponent_1;
}(core_2.DynamicFormControlComponent));
exports.DynamicFoundationFormControlComponent = DynamicFoundationFormControlComponent;
//# sourceMappingURL=dynamic-foundation-form-control.component.js.map